<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, onMounted, onUnmounted } from 'vue';
import { SVG } from '@svgdotjs/svg.js';
import { calculateLinePath, getElementPosition } from '@/lib/line';

const props = defineProps<{
    color: string,
    size: number,
    dash?: boolean,
    ending: string,
    lineText: boolean,
    fontFamily?: string,
    startId: string,
    endId: string
}>();

const svgContainer = ref<HTMLDivElement | null>(null);

let draw: any;
let line: any;
let text: any;
let arrow: any;


const updateLine = () => {
    const startPos = getElementPosition(props.startId);
    const endPos = getElementPosition(props.endId);
    const calculatedPath = calculateLinePath(startPos, endPos, props.size);
    const dash = props.dash ? '10 5' : undefined;
    const path = line.plot(calculatedPath).stroke({ color: props.color, width: props.size, dasharray: dash }).fill('none');

    if (text) {
        const pathLength = path.length();
        const middlePoint = path.pointAt(pathLength / 2);
        text.attr({
            'text-ancher':'middle',
            'dominant-baseline': 'central',
            'x': middlePoint.x, 
            'y': middlePoint.y 
        });
    }

    if (arrow && props.ending !== 'none') {
        const pathLength = path.length();
        const endPoint = path.pointAt(pathLength);
        const beforeEndPoint = path.pointAt(pathLength - 10);

        const arrowAngle = Math.atan2(endPoint.y - beforeEndPoint.y, endPoint.x - beforeEndPoint.x);
        const factor = props.size === 1 ? 7 : 5; 
        const arrowSize = props.size * factor;

        const arrowPath = `M ${endPoint.x} ${endPoint.y} L ${endPoint.x - arrowSize * Math.cos(arrowAngle - Math.PI / 6)} ${endPoint.y - arrowSize * Math.sin(arrowAngle - Math.PI / 6)} L ${endPoint.x - arrowSize * Math.cos(arrowAngle + Math.PI / 6)} ${endPoint.y - arrowSize * Math.sin(arrowAngle + Math.PI / 6)} Z`;
        arrow.plot(arrowPath).fill(props.color);
    }
};

const initializeSVG = () => {
    if (!svgContainer.value) return;

    draw = SVG().addTo(svgContainer.value).size('100%', '100%');

    line = draw.path(0, 0, 0, 0)
        .stroke({ color: props.color, width: props.size, dasharray: props.dash ? '10 5' : '' })
        .fill('none');

    if (props.ending === 'arrow') {
        arrow = draw.path().fill(props.color);
    }

    if (props.lineText) {
        text = draw.text("Text")
            .font({ family: props.fontFamily, size: 20 })
            .fill('white')
            .stroke({ color: props.color, width: 3 })
            .attr({
                'paint-order': 'stroke',
                'stroke-linecap': 'round',
                'stroke-linejoin': 'round'
            })
            .center(0, 0);
    }

    updateLine();
};

onMounted(() => {
    setTimeout(()=>{
        initializeSVG();
    },1);
    window.addEventListener('resize', updateLine);
});

onUnmounted(() => {
    window.removeEventListener('resize', updateLine);
});
</script>

<template>
    <div ref="svgContainer" class="absolute inset-0 pointer-events-none"></div>
</template>